Binary files patched/.CMakeLists.txt.kate-swp and origin/.CMakeLists.txt.kate-swp differ
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/CMakeLists.txt origin/CMakeLists.txt
--- patched/CMakeLists.txt	2012-01-16 09:52:45.000000000 +0400
+++ origin/CMakeLists.txt	2011-12-20 11:43:24.000000000 +0400
@@ -78,19 +78,6 @@
 OPTION(ENABLE_TSC_CLOCK
              "Enable the usage of the timestamp counter as clock source (use with care)" OFF)
 
-# Integrated tests raise extra problems on some server configurations (without installed X-server).
-# The build-on-demand approach seems more legit here.
-OPTION(BUILD_TESTS
-             "Build integrated CERTI test - Billard" OFF)
-
-OPTION(RTIA_USE_THREAD
-             "[HLA1516 only] Force thread usage instead of independent RTIA process (default)" ON)
-## It seems to be more legit approach to add this defintions to config.h file.
-## The profit is the correct work of automatic IDE parsers.
-##IF(RTIA_USE_THREAD)
-##	add_definitions(-DRTIA_USE_THREAD)
-##ENDIF(RTIA_USE_THREAD)
-
 # The communication channel to RTIA
 OPTION(RTIA_USE_TCP
            "Force TCP socket usage between RTIA and FederateAmbassador (default is Unix Socket)" OFF)
@@ -387,21 +374,6 @@
 ################ LEX YACC Check ####################
 FIND_PACKAGE(LexYacc)
 
-################ Boost Check #######################
-if(RTIA_USE_THREAD)
-  set(Boost_USE_STATIC_LIBS OFF)
-  set(Boost_USE_MULTITHREADED ON)
-  set(Boost_USE_STATIC_RUNTIME ON)
-  find_package( Boost 1.36.0 COMPONENTS thread )
-  if(NOT Boost_FOUND)
-    message(WARNING "libRTIA will not be built.")
-    set(RTIA_USE_THREAD OFF)
-  endif(NOT Boost_FOUND)
-endif(RTIA_USE_THREAD)
-
-## TODO: may be the better solution is to add the appropriate value to config files?
-## The profit is the correct behaviour of automatic IDE parsers.
-
 ## now we may generate the Autotools compatible config.h
 CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake
                             ${CMAKE_CURRENT_BINARY_DIR}/config.h )
@@ -431,17 +403,9 @@
 ADD_SUBDIRECTORY( libHLA )
 ADD_SUBDIRECTORY( libCERTI )
 ADD_SUBDIRECTORY( RTIG )
-# Not sure that it is correct to move the multi-thread build into separate directory.
-# The profit of this approach is that current directory structure is the same.
-if(RTIA_USE_THREAD)
-  ADD_SUBDIRECTORY( libRTIA )
-else(RTIA_USE_THREAD)
-  ADD_SUBDIRECTORY( RTIA )
-  ADD_SUBDIRECTORY( libRTI )
-endif(RTIA_USE_THREAD)
-IF(BUILD_TESTS)
-  ADD_SUBDIRECTORY( test )
-ENDIF(BUILD_TESTS)
+ADD_SUBDIRECTORY( RTIA )
+ADD_SUBDIRECTORY( libRTI )
+ADD_SUBDIRECTORY( test )
 ADD_SUBDIRECTORY( doc )
 ADD_SUBDIRECTORY( scripts )
 
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/RTIA/Communications.cc origin/RTIA/Communications.cc
--- patched/RTIA/Communications.cc	2012-01-19 15:21:46.000000000 +0400
+++ origin/RTIA/Communications.cc	2010-03-23 16:13:27.000000000 +0300
@@ -36,9 +36,6 @@
 #include <iostream>
 #include <cstdlib>
 
-#include <sys/time.h>
-#include <limits>
-
 using std::ifstream ;
 using std::ios ;
 using std::cout ;
@@ -86,27 +83,12 @@
 
 // ----------------------------------------------------------------------------
 //! Communications.
-#ifdef RTIA_USE_THREAD
-Communications::Communications( LibRTIABufSet *_bufSet ) {
-	bufSetRef = _bufSet;
-#else // RTIA_USE_THREAD
-Communications::Communications(int RTIA_port, int RTIA_fd ) {
-	socketUN = new SocketUN();
-    // Federate/RTIA link creation.
-    if (0 <= RTIA_fd) {
-      socketUN->setSocketFD(RTIA_fd);
-    } else if (0 <= RTIA_port) {
-      if (socketUN->connectUN(RTIA_port) == -1)
-        exit(EXIT_FAILURE);
-    } else {
-      exit(EXIT_FAILURE);
-    }
-    
-#endif // RTIA_USE_THREAD
-
+Communications::Communications(int RTIA_port, int RTIA_fd)
+{
     char nom_serveur_RTIG[200] ;
     const char *default_host = "localhost" ;
 
+    socketUN = new SocketUN();
 #ifdef FEDERATION_USES_MULTICAST
     socketMC = new SocketMC();
 #endif
@@ -120,6 +102,16 @@
 #endif
     socketUDP = new SocketUDP();
 
+    // Federate/RTIA link creation.
+    if (0 <= RTIA_fd) {
+      socketUN->setSocketFD(RTIA_fd);
+    } else if (0 <= RTIA_port) {
+      if (socketUN->connectUN(RTIA_port) == -1)
+        exit(EXIT_FAILURE);
+    } else {
+      exit(EXIT_FAILURE);
+    }
+
     // RTIG TCP link creation.
     const char *certihost = NULL ;
     ifstream file("RTIA.dat", ios::in);
@@ -156,9 +148,7 @@
     closeMsg.send(socketTCP, NM_msgBufSend);
     socketTCP->close();
 
-#ifndef RTIA_USE_THREAD
     delete socketUN;
-#endif
 #ifdef FEDERATION_USES_MULTICAST
     delete socketMC;
 #endif
@@ -177,11 +167,7 @@
     //               "type %d",req->type);
     assert(req != NULL);
     D.Out(pdRequest, "Sending Request to Federate, Name %s, Type %d.", req->getMessageName(),req->getMessageType());
-#ifdef RTIA_USE_THREAD
-	bufSetRef->amb2fed.push( req );
-#else // RTIA_USE_THREAD
     req->send(socketUN, msgBufSend);
-#endif // RTIA_USE_THREAD
     // G.Out(pdGendoc,"exit  Communications::requestFederateService");
 }
 
@@ -208,130 +194,78 @@
 Communications::readMessage(int &n, NetworkMessage **msg_reseau, Message **msg,
                             struct timeval *timeout)
 {
+    const int tcp_fd(socketTCP->returnSocket());
+    const int udp_fd(socketUDP->returnSocket());
+
+    int max_fd = 0; // not used for _WIN32
+    fd_set fdset ;
+    FD_ZERO(&fdset);
+
+    if (msg_reseau) {
+        FD_SET(tcp_fd, &fdset);
+        FD_SET(udp_fd, &fdset);
+#ifndef _WIN32
+	max_fd = std::max(max_fd, std::max(tcp_fd, udp_fd));
+#endif
+    }
+    if (msg) {
+        FD_SET(socketUN->returnSocket(), &fdset);
+#ifndef _WIN32
+	max_fd = std::max(max_fd, socketUN->returnSocket());
+#endif
+    }
+
+#ifdef FEDERATION_USES_MULTICAST
+    // if multicast link is initialized (during join federation).
+    if (_est_init_mc) {
+        FD_SET(_socket_mc, &fdset);
+#ifndef _WIN32
+        max_fd = std::max(max_fd, _socket_mc);
+#endif
+   }
+#endif
+
     if (msg_reseau && !waitingList.empty()) {
         // One message is in waiting buffer.        
         *msg_reseau = waitingList.front();
         waitingList.pop_front();                
         n = 1 ;
-    } else if (msg_reseau && socketTCP->isDataReady()) {
+    }
+    else if (msg_reseau && socketTCP->isDataReady()) {
         // Datas are in TCP waiting buffer.
         // Read a message from RTIG TCP link.
     	*msg_reseau = NM_Factory::receive(socketTCP);
         n = 1 ;
-    } else if (msg_reseau && socketUDP->isDataReady()) {
+    }
+    else if (msg_reseau && socketUDP->isDataReady()) {
         // Datas are in UDP waiting buffer.
         // Read a message from RTIG UDP link.
     	*msg_reseau = NM_Factory::receive(socketUDP);
         n = 1 ;
-#ifndef RTIA_USE_THREAD
-	// FIXME: it seems useless to check msg parameter
-    } else if (msg && socketUN->isDataReady()) {
+    }
+    else if (msg && socketUN->isDataReady()) {
         // Datas are in UNIX waiting buffer.
         // Read a message from federate UNIX link.
     	*msg = M_Factory::receive(socketUN);
         n = 2 ;
-#endif // RTIA_USE_THREAD
-	} else {
-		
-		// FIXME: the idea to separate this code into independent functions
-		// accorting to chosen build option seems rather legit.
-		
-		const int tcp_fd(socketTCP->returnSocket());
-		const int udp_fd(socketUDP->returnSocket());
-
-		int max_fd = 0; // not used for _WIN32
-		fd_set fdset ;
-		FD_ZERO(&fdset);
-
-		#ifndef RTIA_USE_THREAD
-		if (msg) {
-			FD_SET(socketUN->returnSocket(), &fdset);
-		#ifndef _WIN32
-			max_fd = std::max(max_fd, socketUN->returnSocket());
-		#endif
-		}
-		#endif // RTIA_USE_THREAD
-		
-		if (msg_reseau) {
-			FD_SET(tcp_fd, &fdset);
-			FD_SET(udp_fd, &fdset);
-		#ifndef _WIN32
-			max_fd = std::max(max_fd,std::max(tcp_fd, udp_fd));
-		#endif
-		}
-		
-		#ifdef FEDERATION_USES_MULTICAST
-		// if multicast link is initialized (during join federation).
-		if (_est_init_mc) {
-			FD_SET(_socket_mc, &fdset);
-		#ifndef _WIN32
-			max_fd = std::max(max_fd, _socket_mc);
-		#endif
-		}
-		#endif
-		
+    }
+    else {
         // waitingList is empty and no data in TCP buffer.
         // Wait a message (coming from federate or network).
-        
-#ifdef RTIA_USE_THREAD
-		timeval point, zero = {0,0}, max_timeout;
-		max_timeout.tv_sec = std::numeric_limits<time_t>::max();
-		max_timeout.tv_usec = std::numeric_limits<suseconds_t>::max();
-		if ( !timeout ) {
-			timeout = &max_timeout;
-		} else {
-			gettimeofday( &point, NULL );
-			if ( max_timeout.tv_sec - point.tv_sec <= timeout->tv_sec ) {
-				*timeout = max_timeout;
-			} else {
-				timeout->tv_sec += point.tv_sec;
-				if ( 1000000 - timeout->tv_usec < point.tv_usec ) {
-					timeout->tv_usec = 2000000 - timeout->tv_usec - point.tv_usec;
-					timeout->tv_sec += 1;
-				} else timeout->tv_usec += point.tv_usec;
-			}
-		}
-		// TODO: check if the polling selection works properly on windows.
-		do { int ret_val = select( max_fd+1, &fdset, NULL, NULL, &zero );
-#else // RTIA_USE_THREAD
-			int ret_val = select( max_fd+1, &fdset, NULL, NULL, timeout );
-#endif // RTIA_USE_THREAD
-			// select() return the number of ready descriptors which may be zero if the timeout expires before
-			// anything interesting happens. On error, -1 is returned, and errno is set appropriately.
-			if ( ret_val < 0 ) {
-				// WARNING: the purpose of the separated error handling is not clear
-			#ifdef _WIN32
-				if (WSAGetLastError() == WSAEINTR) {
-			#else
-				if (errno == EINTR) {
-			#endif
-					throw NetworkSignal("EINTR on select"); 
-				} else {
-					throw NetworkError("Unexpected errno on select");
+#ifdef _WIN32
+        if (select(max_fd, &fdset, NULL, NULL, timeout) < 0) {
+            if (WSAGetLastError() == WSAEINTR)
+#else
+        if (select(max_fd+1, &fdset, NULL, NULL, timeout) < 0) {
+            if (errno == EINTR)
+#endif 
+            {
+                throw NetworkSignal("EINTR on select");
+                }
+				else {
+                 throw NetworkError("Unexpected errno on select");
 				}
-			}
-#ifdef RTIA_USE_THREAD
-			gettimeofday( &point, NULL );
-			if ( ret_val > 0 || msg && !bufSetRef->fed2amb.empty() ) break;
-			FD_ZERO(&fdset);
-			if (msg_reseau) {
-				FD_SET(tcp_fd, &fdset);
-				FD_SET(udp_fd, &fdset);
-			}
-			#ifdef FEDERATION_USES_MULTICAST
-			if (_est_init_mc) {
-				FD_SET(_socket_mc, &fdset);
-			}
-			#endif
-		} while ( point.tv_sec < timeout->tv_sec ||
-			point.tv_sec == timeout->tv_sec && point.tv_usec < timeout->tv_usec
-		);
-		// WARNING: Windows does not modify timeout parameter
-		if ( timeout != &max_timeout ) {
-			timeout->tv_sec -= point.tv_sec;
-			timeout->tv_usec -= point.tv_usec;
-		} else timeout = NULL;
-#endif // RTIA_USE_THREAD
+        }
 
         // At least one message has been received, read this message.
 
@@ -355,18 +289,14 @@
             // Read a message coming from the UDP link with RTIG.
         	(*msg_reseau) = NM_Factory::receive(socketUDP);
             n = 1 ;
-#ifndef RTIA_USE_THREAD
-        } else if (FD_ISSET(socketUN->returnSocket(), &fdset)) {
+        }
+        else if (FD_ISSET(socketUN->returnSocket(), &fdset)) {
             // Read a message coming from the federate.
 			*msg = M_Factory::receive(socketUN);
             n = 2 ;
-#else
-		} else if ( msg && !bufSetRef->fed2amb.empty() ) {
-			// Federate buffer stores message
-			*msg = bufSetRef->fed2amb.pull();
-			n = 2;
-#endif
-        } else {
+        }
+        else
+        {
             // select() timeout occured
             n = 3;
         }
@@ -415,22 +345,14 @@
 void
 Communications::sendUN(Message *Msg)
 {
-#ifdef RTIA_USE_THREAD
-	bufSetRef->amb2fed.push( Msg );
-#else // RTIA_USE_THREAD
     Msg->send(socketUN, msgBufSend);
-#endif // RTIA_USE_THREAD
 }
 
 // ----------------------------------------------------------------------------
 Message*
 Communications::receiveUN()
 {
-#ifdef RTIA_USE_THREAD
-	Message* msg = bufSetRef->fed2amb.pull();
-#else // RTIA_USE_THREAD
 	Message* msg = M_Factory::receive(socketUN);
-#endif // RTIA_USE_THREAD
 	return msg;
 }
 
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/RTIA/Communications.hh origin/RTIA/Communications.hh
--- patched/RTIA/Communications.hh	2012-01-19 14:40:53.000000000 +0400
+++ origin/RTIA/Communications.hh	2010-02-27 19:53:36.000000000 +0300
@@ -24,7 +24,6 @@
 #ifndef _CERTI_COMMUNICATIONS_HH
 #define _CERTI_COMMUNICATIONS_HH
 
-#include "config.h"
 #include "certi.hh"
 #include "NetworkMessage.hh"
 #include "Message.hh"
@@ -35,10 +34,6 @@
 #include "SocketMC.hh"
 #endif
 
-#ifdef RTIA_USE_THREAD
-#include "../libRTIA/librtia_buf.hpp"
-#endif
-
 #include <list>
 
 namespace certi {
@@ -52,11 +47,7 @@
 class Communications
 {
 public:
-#ifdef RTIA_USE_THREAD
-    Communications( LibRTIABufSet *bufSet );
-#else // RTIA_USE_THREAD
-	Communications( int RTIA_port, int RTIA_fd );
-#endif // RTIA_USE_THREAD
+    Communications(int RTIA_port, int RTIA_fd);
     ~Communications();
 
     /**
@@ -107,11 +98,7 @@
     MessageBuffer NM_msgBufSend;
     MessageBuffer msgBufSend;
 
-#ifdef RTIA_USE_THREAD
-	LibRTIABufSet *bufSetRef;
-#else // RTIA_USE_THREAD
     SocketUN *socketUN;
-#endif // RTIA_USE_THREAD
 #ifdef FEDERATION_USES_MULTICAST
     SocketMC *socketMC;
 #endif
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/RTIA/DeclarationManagement.cc origin/RTIA/DeclarationManagement.cc
--- patched/RTIA/DeclarationManagement.cc	2012-01-16 10:10:49.000000000 +0400
+++ origin/RTIA/DeclarationManagement.cc	2011-09-03 01:42:24.000000000 +0400
@@ -371,11 +371,11 @@
 {
     G.Out(pdGendoc,"enter DeclarationManagement::startRegistrationForObjectClass");
 
-    DEFINE_REQ( M_Start_Registration_For_Object_Class );
+    M_Start_Registration_For_Object_Class req;
 
-    req->setObjectClass(the_class);
+    req.setObjectClass(the_class);
 
-    comm->requestFederateService(req);
+    comm->requestFederateService(&req);
 
     G.Out(pdGendoc,"exit  DeclarationManagement::startRegistrationForObjectClass");
 }
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/RTIA/FederationManagement.cc origin/RTIA/FederationManagement.cc
--- patched/RTIA/FederationManagement.cc	2012-01-16 10:04:06.000000000 +0400
+++ origin/RTIA/FederationManagement.cc	2011-09-01 17:50:55.000000000 +0400
@@ -466,15 +466,15 @@
 {
     D.Out(pdInit, "Announce Synchronization Point \"%s\"(%s).", label.c_str(), tag.c_str());
 
-    DEFINE_REQ( M_Announce_Synchronization_Point );
+    M_Announce_Synchronization_Point req;
 
-    req->setLabel(label);
-    req->setTag(tag);
+    req.setLabel(label);
+    req.setTag(tag);
 
     // adding label to list of synchronizations to be done.
     _synchronizationLabels.insert(label);
 
-    comm->requestFederateService(req);
+    comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
@@ -483,11 +483,13 @@
 {
     D.Out(pdInit, "Synchronization Point Registration Failed \"%s\".",
           label.c_str());
-	G.Out(pdGendoc,"enter FederationManagement::synchronizationPointRegistrationFailed");
 
-	DEFINE_REQ( M_Synchronization_Point_Registration_Failed );
-    req->setLabel(label);
-    comm->requestFederateService(req);
+    M_Synchronization_Point_Registration_Failed req;
+
+    G.Out(pdGendoc,"enter FederationManagement::synchronizationPointRegistrationFailed");
+    req.setLabel(label);
+
+    comm->requestFederateService(&req);
 
     G.Out(pdGendoc,"exit  FederationManagement::synchronizationPointRegistrationFailed");
 
@@ -499,11 +501,13 @@
 {
     D.Out(pdInit, "Synchronization Point Registration Succeeded \"%s\".",
           label.c_str());
-	G.Out(pdGendoc,"enter FederationManagement::synchronizationPointRegistrationSucceeded");
 
-    DEFINE_REQ( M_Synchronization_Point_Registration_Succeeded );
-    req->setLabel(label);
-    comm->requestFederateService(req);
+    M_Synchronization_Point_Registration_Succeeded req;
+
+    G.Out(pdGendoc,"enter FederationManagement::synchronizationPointRegistrationSucceeded");
+    req.setLabel(label);
+
+    comm->requestFederateService(&req);
 
     G.Out(pdGendoc,"exit  FederationManagement::synchronizationPointRegistrationSucceeded");
 
@@ -515,9 +519,10 @@
 {
     D.Out(pdInit, "Federation Synchronized \"%s\".", label.c_str());
 
-    DEFINE_REQ( M_Federation_Synchronized );
-    req->setLabel(label);
-    comm->requestFederateService(req);
+    M_Federation_Synchronized req;
+
+    req.setLabel(label);
+    comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
@@ -631,9 +636,11 @@
 
     savingState = true ;
 
-    DEFINE_REQ( M_Initiate_Federate_Save );
-    req->setLabel(label);
-    comm->requestFederateService(req);
+    M_Initiate_Federate_Save req;
+
+    req.setLabel(label);
+
+    comm->requestFederateService(&req);
 
     G.Out(pdGendoc,"exit  FederationManagement::initiateFederateSave");
 }
@@ -647,11 +654,11 @@
 
     savingState = false ;
     if (status) {
-        DEFINE_REQ( M_Federation_Saved );
-    	comm->requestFederateService(req);
+        M_Federation_Saved     req;
+    	comm->requestFederateService(&req);
     } else {
-        DEFINE_REQ( M_Federation_Not_Saved );
-    	comm->requestFederateService(req);
+        M_Federation_Not_Saved req;
+    	comm->requestFederateService(&req);
     }
     G.Out(pdGendoc,"exit  FederationManagement::federationSavedStatus");
 }
@@ -704,18 +711,20 @@
     D.Out(pdInit, "Federation restore request %saccepted",
           status ? "" : "not ");
 
+    Message* req;
+
     if (status) {
-    	DEFINE_REQ( M_Request_Federation_Restore_Succeeded );
-		req->setLabel(label);
-		comm->requestFederateService(req);
+    	req = new M_Request_Federation_Restore_Succeeded();
     }
     else {
-		DEFINE_REQ( M_Request_Federation_Restore_Failed );
-        req->setReason(reason);
-		req->setLabel(label);
-		comm->requestFederateService(req);
+    	M_Request_Federation_Restore_Failed* RFRF;
+    	RFRF = new M_Request_Federation_Restore_Failed();
+        RFRF->setReason(reason);
+        req = RFRF;
     }
-
+    req->setLabel(label);
+    comm->requestFederateService(req);
+    delete req;
     G.Out(pdGendoc,"exit  FederationManagement::requestFederationRestoreStatus");
 }
 
@@ -726,8 +735,8 @@
     G.Out(pdGendoc,"enter FederationManagement::federationRestoreBegun");
     D.Out(pdInit, "Federation restore begun");
 
-    DEFINE_REQ( M_Federation_Restore_Begun );
-    comm->requestFederateService(req);
+    M_Federation_Restore_Begun req;
+    comm->requestFederateService(&req);
     G.Out(pdGendoc,"exit  FederationManagement::federationRestoreBegun");
 }
 
@@ -742,12 +751,12 @@
 
     restoringState = true ;
 
-    DEFINE_REQ( M_Initiate_Federate_Restore );
+    M_Initiate_Federate_Restore req;
 
-    req->setFederate(handle);
-    req->setLabel(label);
+    req.setFederate(handle);
+    req.setLabel(label);
 
-    comm->requestFederateService(req);
+    comm->requestFederateService(&req);
     G.Out(pdGendoc,"exit  FederationManagement::initiateFederateRestore");
 }
 
@@ -758,13 +767,17 @@
 
     restoringState = false ;
 
+    Message* req;
+
     if (status) {
-		DEFINE_REQ( M_Federation_Restored );
-		comm->requestFederateService(req);
-	} else {
-		DEFINE_REQ( M_Federation_Not_Restored );
-		comm->requestFederateService(req);
+    	req = new M_Federation_Restored();
     }
+    else {
+    	req = new M_Federation_Not_Restored();
+    }
+
+    comm->requestFederateService(req);
+    delete req;
 }
 
 // ----------------------------------------------------------------------------
diff -U 3 -H -d -r -N -x '*.kdev' -x '.svn*' -x 'CVS*' -- patched/RTIA/ObjectManagement.cc origin/RTIA/ObjectManagement.cc
--- patched/RTIA/ObjectManagement.cc	2012-01-16 10:22:36.000000000 +0400
+++ origin/RTIA/ObjectManagement.cc	2011-10-03 13:17:52.000000000 +0400
@@ -238,17 +238,17 @@
 		EventRetractionHandle the_event,
 		TypeException &)
 {
-	DEFINE_REQ( M_Discover_Object_Instance );
+	M_Discover_Object_Instance req;
 	EventRetraction  event;
 
-	req->setObject(the_object);
-	req->setObjectClass(the_class);
-	req->setDate(the_time);
+	req.setObject(the_object);
+	req.setObjectClass(the_class);
+	req.setDate(the_time);
 	event.setSN(the_event);
-	req->setEventRetraction(event);
-	req->setObjectName(the_name);
+	req.setEventRetraction(event);
+	req.setObjectName(the_name);
 
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 
 	/* The registration of the discovered object in RootObject
 	 * MUST have been done just before putting DO message in FIFO.
@@ -268,24 +268,24 @@
 		EventRetractionHandle the_event,
 		TypeException &)
 {
-	DEFINE_REQ( M_Reflect_Attribute_Values );
+	M_Reflect_Attribute_Values req;
 	EventRetraction event;
 
 	G.Out(pdGendoc,"enter ObjectManagement::reflectAttributeValues with time");
-	req->setObject(the_object);
-	req->setDate(the_time);
+	req.setObject(the_object);
+	req.setDate(the_time);
 	event.setSN(the_event);
-	req->setEventRetraction(event);
-	req->setTag(the_tag);
+	req.setEventRetraction(event);
+	req.setTag(the_tag);
 
-	req->setValuesSize(the_size);
-	req->setAttributesSize(the_size);
+	req.setValuesSize(the_size);
+	req.setAttributesSize(the_size);
 	for (int i=0; i<the_size;++i) {
-		req->setValues(the_values[i],i);
-		req->setAttributes(the_attributes[i],i);
+		req.setValues(the_values[i],i);
+		req.setAttributes(the_attributes[i],i);
 	}
 
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 	G.Out(pdGendoc,"exit  ObjectManagement::reflectAttributeValues with time");
 }
 
@@ -299,21 +299,21 @@
 		const std::string& the_tag,
 		TypeException &)
 {
-	DEFINE_REQ( M_Reflect_Attribute_Values );
+	M_Reflect_Attribute_Values req;
 
 	G.Out(pdGendoc,"enter ObjectManagement::reflectAttributeValues without time");
-	req->setObject(the_object);
-	req->setTag(the_tag);
+	req.setObject(the_object);
+	req.setTag(the_tag);
 
-	req->setValuesSize(the_size);
-	req->setAttributesSize(the_size);
+	req.setValuesSize(the_size);
+	req.setAttributesSize(the_size);
 	for (int i=0; i<the_size;++i) {
-		req->setValues(the_values[i],i);
-		req->setAttributes(the_attributes[i],i);
+		req.setValues(the_values[i],i);
+		req.setAttributes(the_attributes[i],i);
 	}
 
 
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 	G.Out(pdGendoc,"exit  ObjectManagement::reflectAttributeValues without time");
 }
 
@@ -428,21 +428,21 @@
 		EventRetractionHandle the_event,
 		TypeException &)
 {
-	DEFINE_REQ( M_Receive_Interaction );
+	M_Receive_Interaction req;
 	EventRetraction  event;
 
-	req->setInteractionClass(the_interaction);
-	req->setDate(the_time);
+	req.setInteractionClass(the_interaction);
+	req.setDate(the_time);
 	event.setSN(the_event);
-	req->setEventRetraction(event);
-	req->setTag(the_tag);
-	req->setParametersSize(the_size);
-	req->setValuesSize(the_size);
+	req.setEventRetraction(event);
+	req.setTag(the_tag);
+	req.setParametersSize(the_size);
+	req.setValuesSize(the_size);
 	for (uint32_t i=0;i<the_size;++i) {
-		req->setParameters(the_parameters[i],i);
-		req->setValues(the_values[i],i);
+		req.setParameters(the_parameters[i],i);
+		req.setValues(the_values[i],i);
 	}
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
@@ -455,17 +455,17 @@
 		const std::string& the_tag,
 		TypeException &)
 {
-	DEFINE_REQ( M_Receive_Interaction );
+	M_Receive_Interaction req;
 
-	req->setInteractionClass(the_interaction);
-	req->setTag(the_tag);
-	req->setParametersSize(the_size);
-	req->setValuesSize(the_size);
+	req.setInteractionClass(the_interaction);
+	req.setTag(the_tag);
+	req.setParametersSize(the_size);
+	req.setValuesSize(the_size);
 	for (uint32_t i=0;i<the_size;++i) {
-		req->setParameters(the_parameters[i],i);
-		req->setValues(the_values[i],i);
+		req.setParameters(the_parameters[i],i);
+		req.setValues(the_values[i],i);
 	}
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 }
 
 // ----------------------------------------------------------------------------
@@ -548,16 +548,16 @@
 		TypeException &)
 
 {
-	DEFINE_REQ( M_Remove_Object_Instance );
+	M_Remove_Object_Instance req;
 	EventRetraction    event;
 
-	req->setObject(the_object);
+	req.setObject(the_object);
 	event.setSN(the_event);
-	req->setEventRetraction(event);
-	req->setTag(the_tag);
-	req->setDate(theTime);
+	req.setEventRetraction(event);
+	req.setTag(the_tag);
+	req.setDate(theTime);
 
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 
 	rootObject->deleteObjectInstance(the_federate, the_object, theTime, the_tag);
 }
@@ -570,12 +570,12 @@
 		const std::string& the_tag,
 		TypeException &)
 {
-	DEFINE_REQ( M_Remove_Object_Instance );
+	M_Remove_Object_Instance req;
 
-	req->setObject(the_object);
-	req->setTag(the_tag);
+	req.setObject(the_object);
+	req.setTag(the_tag);
 
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 
 	rootObject->deleteObjectInstance(the_federate, the_object, the_tag);
 }
@@ -755,16 +755,16 @@
 		uint32_t attribArraySize,
 		TypeException &)
 {
-	DEFINE_REQ( M_Provide_Attribute_Value_Update );
+	M_Provide_Attribute_Value_Update req;
 
 	G.Out(pdGendoc,"enter ObjectManagement::provideAttributeValueUpdate");
-	req->setObject(the_object);
-	req->setAttributesSize(attribArraySize);
+	req.setObject(the_object);
+	req.setAttributesSize(attribArraySize);
 	for (uint32_t i = 0 ; i < attribArraySize ; ++i) {
-		req->setAttributes(the_attributes[i],i);
+		req.setAttributes(the_attributes[i],i);
 	}
 
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 	G.Out(pdGendoc,"exit  ObjectManagement::provideAttributeValueUpdate");
 }
 
@@ -795,17 +795,18 @@
 ObjectClassHandle
 ObjectManagement::getObjectClassHandle(const std::string& theName)
 {
-	ObjectClassHandle handle ;
-	G.Out(pdGendoc,"enter ObjectManagement::getObjectClassHandle");
-	try {
-		handle = rootObject->ObjectClasses->getObjectClassHandle(theName);
-		G.Out(pdGendoc,"exit  ObjectManagement::getObjectClassHandle");
-		return handle;
-	}
-	catch (NameNotFound) {
-		G.Out(pdGendoc,"exit  ObjectManagement::getObjectClassHandle on NameNotFound");
-		throw NameNotFound(theName);
-	}
+    ObjectClassHandle handle ;
+    G.Out(pdGendoc,"enter ObjectManagement::getObjectClassHandle");
+    try {
+        handle = rootObject->ObjectClasses->getObjectClassHandle(theName);
+        G.Out(pdGendoc,"exit  ObjectManagement::getObjectClassHandle");
+
+    }
+    catch (NameNotFound&) {
+        G.Out(pdGendoc,"exit  ObjectManagement::getObjectClassHandle on NameNotFound");
+        throw NameNotFound(theName);
+    }
+    return handle;
 }
 
 
@@ -996,17 +997,17 @@
 		const uint16_t attribArraySize,
 		TypeException &e) {
 
-	DEFINE_REQ( M_Attributes_In_Scope );
+	M_Attributes_In_Scope req;
 
 	G.Out(pdGendoc,"enter ObjectManagement::attributesInScope");
 
-	req->setObject(theObject);
-	req->setAttributesSize(attribArraySize);
+	req.setObject(theObject);
+	req.setAttributesSize(attribArraySize);
 
 	for (int i = 0 ; i < attribArraySize ; i++)
-		req->setAttributes(attribArray[i],i);
+		req.setAttributes(attribArray[i],i);
 
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 
 	G.Out(pdGendoc,"exit  ObjectManagement::attributesInScope");
 }
@@ -1022,17 +1023,17 @@
 		const uint16_t attribArraySize,
 		TypeException &e) {
 
-	DEFINE_REQ( M_Attributes_Out_Of_Scope );
+	M_Attributes_Out_Of_Scope req;
 
 	G.Out(pdGendoc,"enter ObjectManagement::attributesOutScope");
 
-	req->setObject(theObject);
-	req->setAttributesSize(attribArraySize);
+	req.setObject(theObject);
+	req.setAttributesSize(attribArraySize);
 
 	for (int i = 0 ; i < attribArraySize ; i++)
-		req->setAttributes(attribArray[i],i);
+		req.setAttributes(attribArray[i],i);
 
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 
 	G.Out(pdGendoc,"exit  ObjectManagement::attributesOutScope");
 }
@@ -1072,17 +1073,17 @@
 		const uint16_t attribArraySize,
 		TypeException &e) {
 
-	DEFINE_REQ( M_Turn_Updates_On_For_Object_Instance );
+	M_Turn_Updates_On_For_Object_Instance req;
 
 	G.Out(pdGendoc,"enter ObjectManagement::turnUpdatesOnForObjectInstance");
 
-	req->setObject(theObject);
-	req->setAttributesSize(attribArraySize);
+	req.setObject(theObject);
+	req.setAttributesSize(attribArraySize);
 
 	for (int i = 0 ; i < attribArraySize ; i++)
-		req->setAttributes(attribArray[i],i);
+		req.setAttributes(attribArray[i],i);
 
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 
 	G.Out(pdGendoc,"exit  ObjectManagement::turnUpdatesOnForObjectInstance");
 }
@@ -1098,17 +1099,17 @@
 		const uint16_t attribArraySize,
 		TypeException &e) {
 
-	DEFINE_REQ( M_Turn_Updates_Off_For_Object_Instance );
+	M_Turn_Updates_Off_For_Object_Instance req;
 
 	G.Out(pdGendoc,"enter ObjectManagement::turnUpdatesOffForObjectInstance");
 
-	req->setObject(theObject);
-	req->setAttributesSize(attribArraySize);
+	req.setObject(theObject);
+	req.setAttributesSize(attribArraySize);
 
 	for (int i = 0 ; i < attribArraySize ; i++)
-		req->setAttributes(attribArray[i],i);
+		req.setAttributes(attribArray[i],i);
 
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 
 	G.Out(pdGendoc,"exit  ObjectManagement::turnUpdatesOffForObjectInstance");
 }
@@ -1117,21 +1118,21 @@
 void 
 ObjectManagement::nameReservationSucceeded(const std::string &reservedName)
 {
-	DEFINE_REQ( M_Reserve_Object_Instance_Name_Succeeded );
+	M_Reserve_Object_Instance_Name_Succeeded req;
 
-	req->setObjectName(reservedName);
+	req.setObjectName(reservedName);
 
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 }
 
 void 
 ObjectManagement::nameReservationFailed(const std::string &reservedName)
 {
-	DEFINE_REQ( M_Reserve_Object_Instance_Name_Failed );
+	M_Reserve_Object_Instance_Name_Failed req;
 
-	req->setObjectName(reservedName);
+	req.setObjectName(reservedName);
 
-	comm->requestFederateService(req);
+	comm->requestFederateService(&req);
 }
 
 
